diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/include/ChangeLog libg++-2.5.3linux.2/include/ChangeLog
*** libg++-2.5.3/include/ChangeLog	Mon Nov 29 10:47:24 1993
--- libg++-2.5.3linux.2/include/ChangeLog	Mon Dec 20 08:54:21 1993
***************
*** 1,3 ****
--- 1,7 ----
+ Sat Dec 11 09:11:55 1993  H.J. Lu (hlu@nighthawk)
+ 
+ 	* sys/cdefs.h: new file.
+ 
  Mon Nov 29 10:43:57 1993  Ian Lance Taylor  (ian@tweedledumb.cygnus.com)
  
  	* dis-asm.h (enum dis_insn_tyupe): Remove non-ANSI trailing comma.
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/include/sys/cdefs.h libg++-2.5.3linux.2/include/sys/cdefs.h
*** libg++-2.5.3/include/sys/cdefs.h	Wed Dec 31 19:00:00 1969
--- libg++-2.5.3linux.2/include/sys/cdefs.h	Thu Jan 27 17:43:46 1994
***************
*** 0 ****
--- 1,143 ----
+ /* Copyright (C) 1992, 1993 Free Software Foundation, Inc.
+ This file is part of the GNU C Library.
+ 
+ The GNU C Library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public License as
+ published by the Free Software Foundation; either version 2 of the
+ License, or (at your option) any later version.
+ 
+ The GNU C Library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+ 
+ You should have received a copy of the GNU Library General Public
+ License along with the GNU C Library; see the file COPYING.LIB.  If
+ not, write to the Free Software Foundation, Inc., 675 Mass Ave,
+ Cambridge, MA 02139, USA.  */
+ 
+ #ifndef	_SYS_CDEFS_H
+ 
+ #define	_SYS_CDEFS_H	1
+ 
+ #ifdef __GNU_LIBRARY__
+ #include <features.h>
+ #endif
+ 
+ #ifdef	__GNUC__
+ 
+ #define	__P(args)	args	/* GCC can always grok prototypes.  */
+ #define	__DOTS		, ...
+ 
+ /* Figure out how to declare functions that (1) depend only on their
+    parameters and have no side effects, or (2) don't return.  */
+ 
+ #if __GNUC__ < 2 || (__GNUC__ == 2 && __GNUC_MINOR__ < 5) || defined(__cplusplus)
+   /* Old GCC way. */
+ #ifndef	__CONSTVALUE
+ #define	__CONSTVALUE	__const__
+ #define	__CONSTVALUE2
+ #endif
+ #ifndef	__NORETURN
+ #define	__NORETURN	__volatile__
+ #define	__NORETURN2
+ #endif
+ #else
+   /* New GCC way. */
+ #ifndef	__CONSTVALUE
+ #define	__CONSTVALUE
+ #if defined(const) || !defined(__STDC__)
+ #define	__CONSTVALUE2	/* We don't want empty __attribute__ (()). */
+ #else
+ #define	__CONSTVALUE2	__attribute__ ((const))
+ #endif
+ #endif
+ #ifndef	__NORETURN
+ #define	__NORETURN
+ #ifdef noreturn
+ #define	__NORETURN2	/* We don't want empty __attribute__ (()). */
+ #else
+ #define	__NORETURN2	__attribute__ ((noreturn))
+ #endif
+ #endif
+ #endif
+ 
+ #else	/* Not GCC.  */
+ 
+ #define	__inline		/* No inline functions.  */
+ #define	__CONSTVALUE		/* No idempotent functions.  */
+ #define	__CONSTVALUE2
+ #define	__NORETURN		/* No functions-of-no-return.  */
+ #define	__NORETURN2
+ 
+ #if (defined (__STDC__) && __STDC__) || defined (__cplusplus)
+ 
+ #define	__P(args)	args
+ #define	__const		const
+ #define	__signed	signed
+ #define	__volatile	volatile
+ #define	__DOTS		, ...
+ 
+ #else	/* Not ANSI C or C++.  */
+ 
+ #define	__P(args)	()	/* No prototypes.  */
+ #define	__const			/* No ANSI C keywords.  */
+ #define	__signed
+ #define	__volatile
+ #define	__DOTS
+ 
+ #endif	/* ANSI C or C++.  */
+ 
+ #endif	/* GCC.  */
+ 
+ #if __GNUC__ < 2
+ /* In GCC version 2, (__extension__ EXPR) will not complain
+    about GCC extensions used in EXPR under -ansi or -pedantic.  */
+ #define	__extension__
+ #endif
+ 
+ /* For these things, GCC behaves the ANSI way normally,
+    and the non-ANSI way under -traditional.  */
+ 
+ #if defined (__STDC__) && __STDC__
+ 
+ #define	__CONCAT(x,y)	x ## y
+ #define	__STRING(x)	#x
+ 
+ /* This is not a typedef so `const __ptr_t' does the right thing.  */
+ #define __ptr_t void *
+ typedef long double __long_double_t;
+ 
+ #else
+ 
+ #define	__CONCAT(x,y)	x/**/y
+ #define	__STRING(x)	"x"
+ 
+ #define __ptr_t char *
+ typedef double __long_double_t;
+ 
+ #endif
+ 
+ /* The BSD header files use the ANSI keywords unmodified.  (This means that
+    old programs may lose if they use the new keywords as identifiers.)  We
+    define them to their __ versions, which are taken care of above.  */
+ 
+ #ifdef	__USE_BSD
+ /* __attribute__ uses const. */
+ #if 0
+ #define	const		__const
+ #endif
+ #define	signed		__signed
+ #define	volatile	__volatile
+ #endif
+ 
+ /* C++ needs to know that types and declarations are C, not C++.  */
+ #ifdef	__cplusplus
+ #define	__BEGIN_DECLS	extern "C" {
+ #define	__END_DECLS	}
+ #else
+ #define	__BEGIN_DECLS
+ #define	__END_DECLS
+ #endif
+ 
+ #endif	 /* sys/cdefs.h */
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libg++/src/BitSet.h libg++-2.5.3linux.2/libg++/src/BitSet.h
*** libg++-2.5.3/libg++/src/BitSet.h	Fri May 28 20:07:26 1993
--- libg++-2.5.3linux.2/libg++/src/BitSet.h	Thu Jan 27 22:10:28 1994
***************
*** 59,66 ****
                       BitSetBit(BitSet* v, int p);
                       BitSetBit(const BitSetBit& b);
                      ~BitSetBit();
!                      operator int();
    int                operator = (int b);
  };
  
  class BitSet
--- 59,67 ----
                       BitSetBit(BitSet* v, int p);
                       BitSetBit(const BitSetBit& b);
                      ~BitSetBit();
!                      operator int() const;
    int                operator = (int b);
+   int                operator = (const BitSetBit& b);
  };
  
  class BitSet
***************
*** 342,348 ****
  
  inline BitSetBit::~BitSetBit() {}
  
! inline BitSetBit::operator int()
  {
    return src->test(pos);
  }
--- 343,349 ----
  
  inline BitSetBit::~BitSetBit() {}
  
! inline BitSetBit::operator int() const
  {
    return src->test(pos);
  }
***************
*** 350,355 ****
--- 351,363 ----
  inline int BitSetBit::operator = (int b)
  {
    if (b) src->set(pos); else src->clear(pos); return b;
+ }
+ 
+ inline int BitSetBit::operator = (const BitSetBit& b)
+ {
+   int i = (int)b;
+   *this = i;
+   return i;
  }
  
  inline BitSetBit BitSet::operator [] (int i)
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libg++/src/ChangeLog libg++-2.5.3linux.2/libg++/src/ChangeLog
*** libg++-2.5.3/libg++/src/ChangeLog	Wed Dec 22 06:39:54 1993
--- libg++-2.5.3linux.2/libg++/src/ChangeLog	Thu Jan 27 16:48:04 1994
***************
*** 1,3 ****
--- 1,8 ----
+ Wed Dec 29 22:52:43 1993  Mike Stump  (mrs@cygnus.com)
+ 
+ 	* BitSet.h (BitSetBit): Add int operator = (const BitSetBit& b),
+ 	because the default op= would have the wrong semantics.
+ 
  Mon Dec  6 14:14:52 1993  Per Bothner  (bothner@kalessin.cygnus.com)
  
  	* math-68881.h:  Removed.
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libiberty/ChangeLog libg++-2.5.3linux.2/libiberty/ChangeLog
*** libg++-2.5.3/libiberty/ChangeLog	Wed Dec 22 06:39:56 1993
--- libg++-2.5.3linux.2/libiberty/ChangeLog	Mon Dec 20 09:11:01 1993
***************
*** 1,3 ****
--- 1,9 ----
+ Mon Dec 20 09:10:46 1993  H.J. Lu  (hjl@nighthawk)
+ 
+ 	* functions.def: add strsignal.
+ 
+ 	* strsignal.c: add ifdef NEED_strsignal.
+ 
  Fri Dec 17 12:26:07 1993  Kung Hsu  (kung@cirdan.cygnus.com)
  
  	* cplus-dem.c (demangle_arm_pt): New function.  Common code
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libiberty/functions.def libg++-2.5.3linux.2/libiberty/functions.def
*** libg++-2.5.3/libiberty/functions.def	Fri Nov 26 16:55:10 1993
--- libg++-2.5.3linux.2/libiberty/functions.def	Mon Dec 20 08:54:22 1993
***************
*** 60,63 ****
--- 60,64 ----
     if they are not found. */
  
  DEFFUNC(strerror, char*, (), NOTHING)
+ DEFFUNC(strsignal, char*, (), NOTHING)
  DEFFUNC(psignal, void, (signo, message), unsigned signo AND char *message)
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libiberty/strsignal.c libg++-2.5.3linux.2/libiberty/strsignal.c
*** libg++-2.5.3/libiberty/strsignal.c	Sat Nov 27 15:18:59 1993
--- libg++-2.5.3linux.2/libiberty/strsignal.c	Mon Dec 20 08:54:23 1993
***************
*** 388,393 ****
--- 388,395 ----
  }
  
  
+ #ifdef NEED_strsignal
+ 
  /*
  
  NAME
***************
*** 454,459 ****
--- 456,462 ----
    return (msg);
  }
  
+ #endif
  
  /*
  
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/ChangeLog libg++-2.5.3linux.2/libio/ChangeLog
*** libg++-2.5.3/libio/ChangeLog	Wed Dec 22 06:39:57 1993
--- libg++-2.5.3linux.2/libio/ChangeLog	Tue Feb 22 14:38:26 1994
***************
*** 1,3 ****
--- 1,222 ----
+ Mon Feb 21 13:18:20 1994  H.J. Lu  (hjl@jalod)
+ 
+ 	* libio.h (_IO_PENDING_OUTPUT_COUNT(_fp)): return the
+ 	  pending output count in _fp.
+ 
+ Mon Feb 14 23:48:40 1994  Per Bothner  (bothner@kalessin.cygnus.com)
+ 
+ 	* isgetline.cc (istream& istream::getline(char* buf, int len,
+ 	  char delim)): tentative fix. may change in furure.
+ 
+ Sun Feb 13 22:32:31 1994  H.J. Lu  (hjl@jalod)
+ 
+ 	* libioP.h (CHECK_FILE): fix typos for _OLD_IO_MAGIC.
+ 
+ 	* iofread.c (CHECK_FILE):
+ 	* iofwrite.c (CHECK_FILE): return 0 if fp is invalid.
+ 
+ Fri Feb 11 11:08:01 1994  SBPM Marc GINGOLD <marc@david.saclay.cea.fr>
+ 
+ 	* iovfprintf.c (helper_vfprintf): add
+ 
+ 	  hp->_IO_file_flags = _IO_MAGIC|(_IO_IS_FILEBUF+_IO_NO_READS);
+ 
+ Mon Jan 31 09:28:34 1994  H.J. Lu  (hjl@jalod)
+ 
+ 	* fileops.c (_IO_file_underflow): remove the errno == 0
+ 	  testing introduced on Jan. 30.
+ 
+ Sun Jan 30 12:25:09 1994  H.J. Lu  (hjl@jalod)
+ 
+ 	* fileops.c (_IO_file_underflow): set the EOF flag
+ 	  if errno from read is 0, EAGAIN or EWOULDBLOCK.
+ 
+ 	* cleanup.c: check HAVE_GNU_LD instead of __linux__.
+ 
+ Sat Jan 29 23:16:14 1994  H.J. Lu  (hjl@jalod)
+ 
+ 	* fileops.c (_IO_do_write):
+ 	  (_IO_file_underflow):
+ 	  (_IO_file_xsputn):
+ 	  (_IO_default_xsgetn): change "_IO_size_t count" to
+ 	  "_IO_ssize_t count".
+ 
+ Sat Jan 29 06:52:27 1994  H.J. Lu  (hjl@jalod)
+ 
+ 	* fileops.c (_IO_file_fopen):
+ 	  (_IO_file_attach): don't return NULL if errno == ESPIPE while
+ 	  seek failes.
+ 
+ Thu Jan 20 13:48:40 1994  Per Bothner  (bothner@kalessin.cygnus.com)
+ 
+ 	If no characters are read by fgets, ANSI C doesn't allow '\0' to
+ 	be written to the buffer, but it is requried by ANSI C++
+ 	for istream::get and istream::getline.  Both use _IO_getline ...
+ 	* iogetline.c (_IO_getline):  Don't write a '\0' at the end
+ 	of the read data.  The input buffer length does not include
+ 	space for a '\0'.
+ 	* iofgets.c, iogets.c:  Change appropriately.
+ 	Also check for _IO_ERR_SEEN, as required by ANSI.
+ 	* isgetline.cc:  Update accordingly.
+ 
+ Tue Jan 18 10:08:01 1993  H.J. Lu  (hjl@jalod)
+ 
+ 	* libioP.h: modify CHECK_FILE(FILE,RET) to check
+ 	  _IO_MAGIC_MASK.
+ 
+ 	* iofclose.c: don't clear fp->_IO_file_flags. malloc/free will
+ 	  modify it.
+ 
+ Tue Jan  4 01:32:28 1993  H.J. Lu  (hjl@jalod)
+ 
+ 	* genops.c (_IO_default_xsputn):
+ 	  (_IO_default_xsgetn):
+ 	* ioignore.c: change "_IO_size_t count" to
+ 	  "_IO_ssize_t count".
+ 	* iogetline.c: change "_IO_size_t len" to
+ 	  "_IO_ssize_t len".
+ 
+ Sat Jan  1 21:13:59 1993  H.J. Lu  (hjl@jalod)
+ 
+ 	* libioP.h: add CHECK_FILE(FILE,RET).
+ 	* iofclose.c:
+ 	* iofflush.c:
+ 	* iofgetpos.c:
+ 	* iofgets.c:
+ 	* iofprintf.c:
+ 	* iofputs.c:
+ 	* iofread.c:
+ 	* iofscanf.c:
+ 	* iofsetpos.c:
+ 	* ioftell.c:
+ 	* iofwrite.c:
+ 	* iosetbuffer.c:
+ 	* iosetvbuf.c:
+ 	* ioungetc.c: check fp with CHECK_FILE(FILE,RET).
+ 
+ Wed Dec 29 20:59:17 1993  H.J. Lu  (hjl@jalod)
+ 
+ 	* libio.h (_IO_putc): add parentheses for "_ch".
+ 
+ Tue Dec 21 13:02:48 1993  H.J. Lu  (hjl@jalod)
+ 
+ 	* libio.h: include <sys/cdefs.h>. change const to __const.
+ 
+ 	* iovfscanf.c: enforce the sequence of the conversion
+ 	  specification.
+ 
+ 	* genops.c:
+ 	* iopopen.c:
+ 	* iofopen.c:
+ 	* iofclose.c: don't include <stdlib.h> which is included
+ 	  in "libioP.h".
+ 
+ 	* iopopen.c (_IO_proc_close) : check if fp is on the list
+ 	  before close it.
+ 
+ 	* libioP.h: define CLOSED_FILEBUF_FLAGS as the one used to be
+ 	  in fileops.c.
+ 
+ 	* fileops.c: remove the definition of CLOSED_FILEBUF_FLAGS,
+ 	  which is in libioP.h now.
+ 
+ 	* fileops.c (_IO_file_fopen):
+ 	* iofdopen.c (_IO_fdopen):
+ 	* iopopen.c (_IO_proc_open): _flags |= CLOSED_FILEBUF_FLAGS
+ 	  before setting _flags.
+ 
+ 	* iovfprintf.c:
+ 	* cleanup.c:
+ 	* ioperror.c:
+ 	* iovfprintf.c:
+ 	* iovfscanf.c:
+ 	* strfile.h:
+ 	* libioP.h:
+ 	* libio.h:
+ 	* iolibio.h: replace __PARAMS with __P to be compatible with
+ 	  the GNU C library.
+ 
+ 	* iofopen.c (_IO_fopen): don't check fp == NULL after
+ 	  IO_file_init(&fp->_file).
+ 
+ 	* filedoalloc.c: include <unistd.h>.
+ 
+ 	* iolibio.h: check and define _IOLIBIO_H.
+ 
+ 	* config.shared: add $(LIBIO_CONFIG_FLAGS) to rules.
+ 
+ 	* libioP.h: include _LIBIO_CONFIG_H if defined.
+ 	  include <stdlb.h> if __STDC__ is defined.
+ 
+ 	* config/linux.mt: new files. define
+ 
+ 	  LIBIO_CONFIG_FLAGS=-D_LIBIO_CONFIG_H=\"config/linux.h\" -I./stdio
+ 
+ 	* config/linux.h: new file for linux.
+ 
+ 	* iofdopen.c (_IO_fdopen ()): call fcntl () to set up
+ 	  the currect status flag from the flag passing from
+ 	  fdopen ().
+ 
+ 	* fileops.c (_IO_file_attach ()): seek to the current R/W pointer.
+ 
+ 	* floatconv.c (_IO_strtod ()): make "+" and "-" as error.
+ 
+ 	* libioP.h (_IO_ignore):
+ 	  (_IO_least_marker):
+ 	  (_IO_switch_to_main_get_are):
+ 	  (_IO_switch_to_backup_are): 
+ 	  (_IO_syn):
+ 	  (_IO_get_column):
+ 	  (_IO_set_column):
+ 	  (_IO_str_finish):
+ 	  (IO_nobackup_pbackfail): new declaration.
+ 	  (_IO_flush_all):
+ 	  (_IO_flush_all_linebuffered): use ___P((void));
+ 
+ 	* iolibio.h (_IO_fscanf):
+ 	  (_IO_printf):
+ 	  (_IO_vfscanf):	  
+ 	  (_IO_fread): new declaration.
+ 
+ 	* cleanup.c: for linux, comment out "function_alias" and use
+ 	  text_set_element instead.
+ 
+ 	* libio.h: define _IO_uid_t and _IO_HAVE_ST_BLKSIZE
+ 	  as _G_xxxxxxxx.
+ 
+ 	* iomanip.h (template<class TP> class iapp):
+ 	  change ostream to istream.
+ 
+ 	* libioP.h:
+ 	* cleanup.c:
+ 	* filedoalloc.c: ifdef out _IO_cleanup_registration_needed
+ 	  stuff for Linux. it is handled in cleanup.c.
+ 
+ 	* configure.in (CLEAN): add tmp-params.h, dummy.C,
+ 	  dummy.o, dummy.c, dummy.out, TMP and a.out.
+ 	  add
+ 
+ 		*linux*)         my_target=linux;;
+ 
+ 	  to case "${target}" in. Also remove all libio object files
+ 	  for Linux since they are in libc.a.
+ 
+ 	* iostrerror.c: do nothing if __linux__ is defined.
+ 
+ 	* ioperror.c: add a new version for __linux__. may be 
+ 	  used with glibc.
+ 
+ 	* libioP.h: add _IO_gen_tempname ().
+ 
+ 	* iotempname.c: new file for _IO_gen_tempname (). It is
+ 	  used for the temporary filename functions.
+ 
+ 	* Makefile.in: add iotempname.o.
+ 
+ 	* ioprims.c: #include <unistd.h>. do nothing if
+ 	  __linux__ is defined. also glibc?
+ 
  Mon Dec 20 00:31:21 1993  Per Bothner  (bothner@kalessin.cygnus.com)
  
  	* config.shared (CXXINCLUDES):  Fix quoting of $(NOSTDINC).
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/NEWS libg++-2.5.3linux.2/libio/NEWS
*** libg++-2.5.3/libio/NEWS	Wed Dec 22 06:39:58 1993
--- libg++-2.5.3linux.2/libio/NEWS	Thu Jan 20 17:49:27 1994
***************
*** 1,3 ****
--- 1,5 ----
+ * _IO_getline and streambuf::sgetline no longer write a '\0' at the end.
+ 
  *** Major changes in libio version 0.63 (released with libg++ 2.5.3):
  
  * There is a g++ bug that causes inconsistent name mangling for the
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/cleanup.c libg++-2.5.3linux.2/libio/cleanup.c
*** libg++-2.5.3/libio/cleanup.c	Tue Oct 12 02:28:18 1993
--- libg++-2.5.3linux.2/libio/cleanup.c	Sun Jan 30 14:16:02 1994
***************
*** 1,8 ****
  #include "libioP.h"
  #if _G_HAVE_ATEXIT
  #include <stdlib.h>
  
! typedef void (*voidfunc) _PARAMS((void));
  
  static void _IO_register_cleanup ()
  {
--- 1,29 ----
  #include "libioP.h"
+ 
+ #ifdef HAVE_GNU_LD
+ 
+ #include "stdio.h"
+ #include <unistd.h>
+ #include <ansidecl.h>
+ #include <gnu-stabs.h>
+ 
+ #if 1
+ function_alias(_cleanup, _IO_flush_all, void, (),
+ 		DEFUN_VOID(_cleanup))
+ #else
+ /* We don't want this since we are building the shared library.
+  * We want the shared library selfcontained. __libc_atexit will
+  * ruin it unless we take exit () out of the shared library.
+  */
+ text_set_element(__libc_atexit, _IO_flush_all);
+ #endif
+ 
+ #else
+ 
  #if _G_HAVE_ATEXIT
  #include <stdlib.h>
  
! typedef void (*voidfunc) __P((void));
  
  static void _IO_register_cleanup ()
  {
***************
*** 12,14 ****
--- 33,37 ----
  
  void (*_IO_cleanup_registration_needed)() = _IO_register_cleanup;
  #endif /* _G_HAVE_ATEXIT */
+ 
+ #endif
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/config/linux.h libg++-2.5.3linux.2/libio/config/linux.h
*** libg++-2.5.3/libio/config/linux.h	Wed Dec 31 19:00:00 1969
--- libg++-2.5.3linux.2/libio/config/linux.h	Mon Dec 20 08:54:24 1993
***************
*** 0 ****
--- 1,29 ----
+ #ifndef _CONFIG_LINUX_H
+ #define  _CONFIG_LINUX_H
+ 
+ #undef _STDIO_USES_IOSTREAM
+ #define _STDIO_USES_IOSTREAM 	1
+ 
+ #undef _IO_HAVE_ST_BLKSIZE
+ #define _IO_HAVE_ST_BLKSIZE	1
+ 
+ #define _IO_open	__open
+ #define _IO_close	__close
+ #define	_IO_fork	__fork
+ #define	_IO_fcntl	__fcntl
+ #define _IO__exit	_exit
+ #define _IO_read	__read
+ #define _IO_write	__write
+ #define _IO_lseek	__lseek
+ #define	_IO_getdtablesize	__getdtablesize
+ #define _IO_pipe	__pipe
+ #define _IO_dup2	__dup2
+ #define _IO_execl	execl
+ #define _IO_waitpid	__waitpid
+ #define _IO_stat        __stat
+ #define _IO_getpid      __getpid
+ #define _IO_geteuid     __geteuid
+ #define _IO_getegid     __getegid
+ #define _IO_fstat	__fstat
+ 
+ #endif /* _CONFIG_LINUX_H */
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/config/linux.mt libg++-2.5.3linux.2/libio/config/linux.mt
*** libg++-2.5.3/libio/config/linux.mt	Wed Dec 31 19:00:00 1969
--- libg++-2.5.3linux.2/libio/config/linux.mt	Mon Dec 20 08:54:24 1993
***************
*** 0 ****
--- 1,3 ----
+ # Linux defines those system dependent macros in libio/config/linux.h.
+ LIBIO_CONFIG_FLAGS=-D_LIBIO_CONFIG_H=\"config/linux.h\" -I./stdio
+ 
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/config.shared libg++-2.5.3linux.2/libio/config.shared
*** libg++-2.5.3/libio/config.shared	Wed Dec 22 06:39:58 1993
--- libg++-2.5.3linux.2/libio/config.shared	Thu Jan 27 21:59:39 1994
***************
*** 181,187 ****
  if test -n "${CXXINCLUDES}" ; then
    echo "CXXINCLUDES = ${CXXINCLUDES}" '$(XTRAFLAGS)'
  elif test "${DOING_LIBGXX}" = "true" ; then
!   echo 'CXXINCLUDES = $(NOSTDINC)'" -I. -I${TO_TOPDIR}libio"' -I$(srcdir) -I$(srcdir)/'"${TOLIBGXX}"'$(IO_DIR) -I$(srcdir)/'"${TOLIBGXX}src"' $(WRAP_C_INCLUDES) $(XTRAFLAGS)'
  fi
  if test -n "${CINCLUDES}" ; then
    echo "CINCLUDES = ${CINCLUDES}" '$(XTRAFLAGS)'
--- 181,187 ----
  if test -n "${CXXINCLUDES}" ; then
    echo "CXXINCLUDES = ${CXXINCLUDES}" '$(XTRAFLAGS)'
  elif test "${DOING_LIBGXX}" = "true" ; then
!   echo 'CXXINCLUDES = $(NOSTDINC)'" -I. -I${TO_TOPDIR}libio"' -I$(srcdir) -I$(srcdir)/'"${TOLIBGXX}"'$(IO_DIR) -I$(srcdir)/'"${TOLIBGXX}src -I${TO_TOPDIR}include"' $(WRAP_C_INCLUDES) $(XTRAFLAGS)'
  fi
  if test -n "${CINCLUDES}" ; then
    echo "CINCLUDES = ${CINCLUDES}" '$(XTRAFLAGS)'
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/configure.in libg++-2.5.3linux.2/libio/configure.in
*** libg++-2.5.3/libio/configure.in	Thu Oct 14 17:57:54 1993
--- libg++-2.5.3linux.2/libio/configure.in	Fri Jan 28 12:59:27 1994
***************
*** 11,18 ****
--- 11,36 ----
  
  # per-target:
  
+ : >${package_makefile_frag}
+ 
  case "${target}" in
    *-*-hpux*)       my_target=hpux ;;
+   *linux*)
+  	my_target=linux
+ cat > ${package_makefile_frag} <<!EOF!
+ # Linux has them in libc.a.
+ IO_OBJECTS=
+ 
+ # Linux has them in libc.a.
+ STDIO_WRAP_OBJECTS=
+ 
+ # Linux has them in libc.a.
+ OSPRIM_OBJECTS=
+ 
+ EXTRA_OBJECTS = iotempname.o
+ 
+ !EOF!
+ 	;;
    *-*-sco3.2v4*)   my_target=sco4 ;;
    *-*-isc*)        my_target=isc ;;
    *-*-*)           my_target=${target_cpu}
***************
*** 24,35 ****
  
  TO_TOPDIR=../
  ALL='_G_config.h libio.a libiostream.a $(OSPRIM_OBJECTS)'
! CINCLUDES='-I. -I$(srcdir)'
! CXXINCLUDES='-I. -I$(srcdir)'
  MOSTLYCLEAN='*.o core iostream.list'
! CLEAN='_G_config.h *.a'
  INFO_FILES=iostream
! (. ${srcdir}/config.shared) >${package_makefile_frag}
  
  # post-target:
  
--- 42,53 ----
  
  TO_TOPDIR=../
  ALL='_G_config.h libio.a libiostream.a $(OSPRIM_OBJECTS)'
! CINCLUDES='-I. -I$(srcdir) -I$(srcdir)/../include'
! CXXINCLUDES='-I. -I$(srcdir) -I$(srcdir)/../include'
  MOSTLYCLEAN='*.o core iostream.list'
! CLEAN='tmp-params.h dummy.C dummy.o dummy.c dummy.out TMP a.out _G_config.h *.a'
  INFO_FILES=iostream
! (. ${srcdir}/config.shared) >>${package_makefile_frag}
  
  # post-target:
  
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/filedoalloc.c libg++-2.5.3linux.2/libio/filedoalloc.c
*** libg++-2.5.3/libio/filedoalloc.c	Wed Dec 22 06:39:58 1993
--- libg++-2.5.3linux.2/libio/filedoalloc.c	Fri Jan 28 15:58:25 1994
***************
*** 43,56 ****
--- 43,59 ----
  
  #define _POSIX_SOURCE
  #include "libioP.h"
+ #include <unistd.h>
  #include <sys/types.h>
  #include <sys/stat.h>
  
+ #ifndef __linux__
  /* If this function pointer is non-zero, we should call it.
     It's supposed to make sure _IO_flush_all gets called on exit.
     We call it from _IO_file_doallocate, since that is likely
     to get called by any program that does buffered I/O. */
  void (*_IO_cleanup_registration_needed)();
+ #endif
  
  /*
   * Allocate a file buffer, or switch to unbuffered I/O.
***************
*** 69,77 ****
    register char *p;
    struct stat st;
  
    if (_IO_cleanup_registration_needed)
      (*_IO_cleanup_registration_needed)();
!   
    if (fp->_fileno < 0 || fp->_jumps->__stat(fp, &st) < 0)
      {
        couldbetty = 0;
--- 72,82 ----
    register char *p;
    struct stat st;
  
+ #ifndef __linux__
    if (_IO_cleanup_registration_needed)
      (*_IO_cleanup_registration_needed)();
! #endif
! 
    if (fp->_fileno < 0 || fp->_jumps->__stat(fp, &st) < 0)
      {
        couldbetty = 0;
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/fileops.c libg++-2.5.3linux.2/libio/fileops.c
*** libg++-2.5.3/libio/fileops.c	Fri Dec  3 02:23:20 1993
--- libg++-2.5.3linux.2/libio/fileops.c	Mon Jan 31 09:26:09 1994
***************
*** 79,88 ****
     If a filebuf is unbuffered(), the _shortbuf[1] is used as the buffer.
  */
  
- #define CLOSED_FILEBUF_FLAGS \
-   (_IO_IS_FILEBUF+_IO_NO_READS+_IO_NO_WRITES+_IO_TIED_PUT_GET)
- 
- 
  void
  _IO_file_init(fp)
       register _IO_FILE *fp;
--- 79,84 ----
***************
*** 109,115 ****
    _IO_unsave_markers(fp);
  
    status = fp->_jumps->__close(fp);
!   
    /* Free buffer. */
    _IO_setb(fp, NULL, NULL, 0);
    _IO_setg(fp, NULL, NULL, NULL);
--- 105,111 ----
    _IO_unsave_markers(fp);
  
    status = fp->_jumps->__close(fp);
! 
    /* Free buffer. */
    _IO_setb(fp, NULL, NULL, 0);
    _IO_setg(fp, NULL, NULL, NULL);
***************
*** 170,179 ****
    if (fdesc < 0)
      return NULL;
    fp->_fileno = fdesc;
    fp->_IO_file_flags = 
      _IO_mask_flags(fp, read_write,_IO_NO_READS+_IO_NO_WRITES+_IO_IS_APPENDING);
    if (read_write & _IO_IS_APPENDING)
!     if (fp->_jumps->__seekoff(fp, (_IO_off_t)0, _IO_seek_end) == _IO_pos_BAD)
        return NULL;
    _IO_link_in(fp);
    return fp;
--- 166,177 ----
    if (fdesc < 0)
      return NULL;
    fp->_fileno = fdesc;
+   fp->_IO_file_flags |= CLOSED_FILEBUF_FLAGS;
    fp->_IO_file_flags = 
      _IO_mask_flags(fp, read_write,_IO_NO_READS+_IO_NO_WRITES+_IO_IS_APPENDING);
    if (read_write & _IO_IS_APPENDING)
!     if (fp->_jumps->__seekoff(fp, (_IO_off_t)0, _IO_seek_end)
! 	== _IO_pos_BAD && errno != ESPIPE)
        return NULL;
    _IO_link_in(fp);
    return fp;
***************
*** 184,194 ****
--- 182,209 ----
       _IO_FILE *fp;
       int fd;
  {
+ #if 1
+   struct stat st;
+ #endif
+ 
    if (_IO_file_is_open(fp))
      return NULL;
    fp->_fileno = fd;
    fp->_flags &= ~(_IO_NO_READS+_IO_NO_WRITES);
+ 
+ #if 1
+   /* Get the current position of the file. */
+   if (fp->_jumps->__stat(fp, &st) == 0 && S_ISREG(st.st_mode))
+   {
+     fp->_offset = _IO_pos_BAD;
+     if (fp->_jumps->__seekoff(fp, (_IO_off_t) 0, _IO_seek_cur)
+          == _IO_pos_BAD && errno != ESPIPE)
+     return NULL;
+   }
+ #else
    fp->_offset = _IO_pos_BAD;
+ #endif
+ 
    return fp;
  }
  
***************
*** 214,220 ****
       const char* data;
       _IO_size_t to_do;
  {
!   _IO_size_t count;
    if (to_do == 0)
      return 0;
    if (fp->_flags & _IO_IS_APPENDING)
--- 229,235 ----
       const char* data;
       _IO_size_t to_do;
  {
!   _IO_ssize_t count;
    if (to_do == 0)
      return 0;
    if (fp->_flags & _IO_IS_APPENDING)
***************
*** 245,251 ****
  _IO_file_underflow(fp)
       register _IO_FILE *fp;
  {
!   _IO_size_t count;
  #if 0
    /* SysV does not make this test; take it out for compatibility */
    if (fp->_flags & _IO_EOF_SEEN)
--- 260,266 ----
  _IO_file_underflow(fp)
       register _IO_FILE *fp;
  {
!   _IO_ssize_t count;
  #if 0
    /* SysV does not make this test; take it out for compatibility */
    if (fp->_flags & _IO_EOF_SEEN)
***************
*** 271,280 ****
--- 286,326 ----
  			     fp->_IO_buf_end - fp->_IO_buf_base);
    if (count <= 0)
      {
+ #if 1
+       /* errno may be changed by the signal handler. when we see
+        * errno == 0, we assume the signal is benign :-(.
+        *
+        * We don't need it any more. H.J.
+        */
+ #if 1
+ #define	CHECK_ZERO_ERRNO
+ #else
+ #define	CHECK_ZERO_ERRNO	|| errno == 0
+ #endif
+ #ifdef EAGAIN
+ #if defined(EWOULDBLOCK) && EWOULDBLOCK != EAGAIN
+       if (count == 0 CHECK_ZERO_ERRNO || errno == EAGAIN
+ 	|| errno == EWOULDBLOCK)
+ #else
+       if (count == 0 CHECK_ZERO_ERRNO || errno == EAGAIN)
+ #endif
+ #else
+ #ifdef EWOULDBLOCK
+       if (count == 0 CHECK_ZERO_ERRNO || errno == EWOULDBLOCK)
+ #else
+       if (count == 0 CHECK_ZERO_ERRNO)
+ #endif
+ #endif
+ 	fp->_flags |= _IO_EOF_SEEN;
+       else
+         fp->_flags |= _IO_ERR_SEEN;
+       count = 0;
+ #else
        if (count == 0)
  	fp->_flags |= _IO_EOF_SEEN;
        else
  	fp->_flags |= _IO_ERR_SEEN, count = 0;
+ #endif
    }
    fp->_IO_read_base = fp->_IO_read_ptr = fp->_IO_buf_base;
    fp->_IO_read_end = fp->_IO_buf_base + count;
***************
*** 575,581 ****
    register const char *s = data;
    _IO_size_t to_do = n;
    int must_flush = 0;
!   _IO_size_t count;
  
    if (n <= 0)
      return 0;
--- 621,627 ----
    register const char *s = data;
    _IO_size_t to_do = n;
    int must_flush = 0;
!   _IO_ssize_t count;
  
    if (n <= 0)
      return 0;
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/floatconv.c libg++-2.5.3linux.2/libio/floatconv.c
*** libg++-2.5.3/libio/floatconv.c	Fri Nov 26 21:58:45 1993
--- libg++-2.5.3linux.2/libio/floatconv.c	Mon Dec 20 08:54:25 1993
***************
*** 1111,1116 ****
--- 1111,1118 ----
                                  goto break2;
                          /* no break */
                  case 0:
+ 			/* "+" and "-" should be reported as an error? */
+ 			sign = 0;
  			s = s00;
                          goto ret;
                  case '\t':
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/genops.c libg++-2.5.3linux.2/libio/genops.c
*** libg++-2.5.3/libio/genops.c	Wed Dec 22 06:39:59 1993
--- libg++-2.5.3linux.2/libio/genops.c	Tue Jan 18 11:23:36 1994
***************
*** 25,31 ****
  /* Generic or default I/O operations. */
  
  #include "libioP.h"
- #include <stdlib.h>
  #include <string.h>
  
  void _IO_un_link(fp)
--- 25,30 ----
***************
*** 283,289 ****
      return 0;
    for (;;)
      {
!       _IO_size_t count = f->_IO_write_end - f->_IO_write_ptr; /* Space available. */
        if (count > 0)
  	{
  	  if (count > more)
--- 282,288 ----
      return 0;
    for (;;)
      {
!       _IO_ssize_t count = f->_IO_write_end - f->_IO_write_ptr; /* Space available. */
        if (count > 0)
  	{
  	  if (count > more)
***************
*** 332,338 ****
    register char *s = data;
    for (;;)
      {
!       _IO_size_t count = fp->_IO_read_end - fp->_IO_read_ptr; /* Data available. */
        if (count > 0)
  	{
  	  if (count > more)
--- 331,337 ----
    register char *s = data;
    for (;;)
      {
!       _IO_ssize_t count = fp->_IO_read_end - fp->_IO_read_ptr; /* Data available. */
        if (count > 0)
  	{
  	  if (count > more)
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iofclose.c libg++-2.5.3linux.2/libio/iofclose.c
*** libg++-2.5.3/libio/iofclose.c	Fri Dec  3 02:23:21 1993
--- libg++-2.5.3linux.2/libio/iofclose.c	Sun Feb 13 22:29:51 1994
***************
*** 23,35 ****
  the executable file might be covered by the GNU General Public License. */
  
  #include "libioP.h"
- #include <stdlib.h>
  
  int
  _IO_fclose(fp)
       register _IO_FILE *fp;
  {
    int status = 0;
    COERCE_FILE(fp);
    if (fp->_IO_file_flags & _IO_IS_FILEBUF)
      status = _IO_file_close_it(fp);
--- 23,35 ----
  the executable file might be covered by the GNU General Public License. */
  
  #include "libioP.h"
  
  int
  _IO_fclose(fp)
       register _IO_FILE *fp;
  {
    int status = 0;
+   CHECK_FILE(fp, EOF);
    COERCE_FILE(fp);
    if (fp->_IO_file_flags & _IO_IS_FILEBUF)
      status = _IO_file_close_it(fp);
